require("./main.css");
var $gTuX4$swchelperscjs_class_call_checkcjs = require("@swc/helpers/cjs/_class_call_check.cjs");
var $gTuX4$swchelperscjs_create_classcjs = require("@swc/helpers/cjs/_create_class.cjs");
var $gTuX4$swchelperscjs_object_spreadcjs = require("@swc/helpers/cjs/_object_spread.cjs");
var $gTuX4$swchelperscjs_object_spread_propscjs = require("@swc/helpers/cjs/_object_spread_props.cjs");
var $gTuX4$asupsimpletable = require("@asup/simple-table");
var $gTuX4$reactjsxruntime = require("react/jsx-runtime");
var $gTuX4$asupcontextmenu = require("@asup/context-menu");
var $gTuX4$swchelperscjs_sliced_to_arraycjs = require("@swc/helpers/cjs/_sliced_to_array.cjs");
var $gTuX4$react = require("react");
var $gTuX4$swchelperscjs_to_consumable_arraycjs = require("@swc/helpers/cjs/_to_consumable_array.cjs");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$export(module.exports, "SummaryTableGenerator", function () { return $1c005ff3adb0923f$export$8bd6da0e23c354ec; });
$parcel$export(module.exports, "DatasetJson", function () { return $7bcfaf7be36b5fb3$export$a343c64541036632; });
$parcel$export(module.exports, "DatasetJsonItemClass", function () { return $db8b278ed6b17d1f$export$626c488e6c24a1e8; });








var $db8b278ed6b17d1f$export$a3d0be471ff2ca15;
(function(eItemType) {
    eItemType["string"] = "string";
    eItemType["integer"] = "integer";
    eItemType["float"] = "float";
    eItemType["date"] = "Date";
    eItemType["time"] = "Time";
    eItemType["datetime"] = "DateTime";
})($db8b278ed6b17d1f$export$a3d0be471ff2ca15 || ($db8b278ed6b17d1f$export$a3d0be471ff2ca15 = {}));
var $db8b278ed6b17d1f$export$626c488e6c24a1e8 = /*#__PURE__*/ function() {
    "use strict";
    function DatasetJsonItemClass(newItem) {
        (0, $gTuX4$swchelperscjs_class_call_checkcjs._)(this, DatasetJsonItemClass);
        this._OID = "";
        this._name = "";
        this._label = "";
        this._type = $db8b278ed6b17d1f$export$a3d0be471ff2ca15.string;
        this._length = 8;
        this._OID = newItem.OID;
        this._name = newItem.name;
        this._label = newItem.label;
        this._length = newItem.length;
    }
    (0, $gTuX4$swchelperscjs_create_classcjs._)(DatasetJsonItemClass, [
        {
            key: "OID",
            get: /**
   * Unique identifier
   */ function get() {
                return this._OID;
            }
        },
        {
            key: "name",
            get: /**
   * Item name
   */ function get() {
                return this._name;
            }
        },
        {
            key: "label",
            get: /**
   * Item label
   */ function get() {
                return this._label;
            }
        },
        {
            key: "type",
            get: /**
   * Item type
   */ function get() {
                return this._type;
            }
        },
        {
            key: "length",
            get: /**
   * Assigned item length for strings
   */ function get() {
                return this._length;
            }
        },
        {
            key: "data",
            get: /**
   * Data stored in the clas
   */ function get() {
                return {
                    OID: this._OID,
                    name: this._name,
                    label: this._label,
                    type: this._type,
                    length: this._length
                };
            }
        },
        {
            key: "toString",
            get: /**
   * Stringified version of the class
   */ function get() {
                return JSON.stringify(this.data);
            }
        },
        {
            key: "component",
            get: /**
   * Return JSX span with the class name
   */ function get() {
                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("span", {
                    className: "datasetjson-item",
                    children: this._name
                });
            }
        }
    ]);
    return DatasetJsonItemClass;
}();


var $7bcfaf7be36b5fb3$export$a343c64541036632 = /*#__PURE__*/ function() {
    "use strict";
    function DatasetJsonClass(newJson) {
        (0, $gTuX4$swchelperscjs_class_call_checkcjs._)(this, DatasetJsonClass);
        this._errorText = "";
        this._studyOID = "";
        this._metaDataVersionOID = "CDISC.ADaM.2.1";
        this._name = "";
        this._label = "";
        this._items = [];
        this._itemData = [];
        this._studyOID = newJson.clinicalData.studyOID;
        this._metaDataVersionOID = newJson.clinicalData.metaDataVersionOID;
        var ds = Object.values(newJson.clinicalData.itemGroupData)[0];
        this._name = ds.name;
        this._label = ds.label;
        this.items = ds.items;
        this._itemData = ds.itemData.map(function(arrayRow, ai) {
            var newItem = Object.fromEntries(new Map(ds.items.map(function(item, i) {
                return [
                    item.name,
                    arrayRow[i]
                ];
            })));
            return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, newItem), {
                __rowNumber: ai + 1,
                __isDeleted: false
            });
        });
    }
    (0, $gTuX4$swchelperscjs_create_classcjs._)(DatasetJsonClass, [
        {
            key: "errorText",
            get: /**
   * Error text after internal error
   */ function get() {
                return this._errorText;
            }
        },
        {
            key: "studyOID",
            get: /**
   * studyOID attibute
   */ function get() {
                return this._studyOID;
            },
            set: /**
   * Sets value of studyOID
   */ function set(newValue) {
                if (newValue !== "") this._studyOID = newValue;
            }
        },
        {
            key: "metaDataVersionOID",
            get: function get() {
                return this._metaDataVersionOID;
            }
        },
        {
            key: "name",
            get: /**
   * Data set name
   */ function get() {
                return this._name;
            },
            set: /**
   * Data set name
   */ function set(newValue) {
                if (newValue !== "") this._name = newValue;
            }
        },
        {
            key: "label",
            get: /**
   * Data set label
   */ function get() {
                return this._label;
            },
            set: /**
   * Data set label
   */ function set(newValue) {
                if (newValue !== "") this._label = newValue;
            }
        },
        {
            key: "records",
            get: /**
   * Number of records in the data set
   */ function get() {
                return this.itemData.length;
            }
        },
        {
            key: "items",
            get: /**
   * Items (variables) in the data set
   */ function get() {
                return this._items;
            },
            set: /**
   * Items (variables) in the data set
   */ function set(newItems) {
                if (newItems.length > 0) this._items = newItems.map(function(i) {
                    return i instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8) ? i : new (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)(i);
                });
            }
        },
        {
            key: "simpleTableFields",
            get: function get() {
                return this._items.map(function(item) {
                    return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, item.data), {
                        sortFn: (0, $gTuX4$asupsimpletable.simpleTableSortFn),
                        searchFn: item.type === "string" ? function(row, text) {
                            return row[item.name].toLocaleLowerCase().includes(text.toLocaleLowerCase());
                        } : undefined
                    });
                });
            }
        },
        {
            key: "addItem",
            value: /**
   * Add new item (variable) to the data set
   * @param newItem Add data set item definition to the data set
   * @returns true is successful, false (& sets errorText) is there is an error
   */ function addItem(newItem) {
                if (this.items.map(function(i) {
                    return i.name;
                }).includes(newItem.name)) {
                    this._errorText = "Item name already exists";
                    return false;
                }
                this._items.push(newItem instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8) ? newItem : new (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)(newItem));
                this._itemData.forEach(function(row) {
                    row[newItem.name] = undefined;
                });
                return true;
            }
        },
        {
            key: "removeItem",
            value: /**
   * Removes an item (variable) from the data set and the associated data
   * @param oldItemName Name of the item to remove
   */ function removeItem(oldItemName) {
                var ix = this._items.findIndex(function(i) {
                    return i.name === oldItemName;
                });
                if (ix > -1) {
                    this._items.splice(ix, 1);
                    this._itemData.forEach(function(row) {
                        if (Object.keys(row).includes(oldItemName)) delete row.oldItemName;
                    });
                }
            }
        },
        {
            key: "itemData",
            get: /**
   * Data stored in the data set
   */ function get() {
                return this._itemData.filter(function(row) {
                    return !row.__isDeleted;
                });
            },
            set: /**
   * Data stored in the data set
   */ function set(newItemDataRows) {
                var _this = this;
                this._itemData = newItemDataRows.map(function(row, i) {
                    return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, new Map(_this._items.map(function(item) {
                        return [
                            item.name,
                            row[item.name]
                        ];
                    }))), {
                        __rowNumber: i + 1,
                        __isDeleted: false
                    });
                });
            }
        },
        {
            key: "addItemData",
            value: /**
   * Add single row to the data
   * @param newItemDataRow New row data
   * @returns true is successful, false (& sets errorText) is there is an error
   */ function addItemData(newItemDataRow) {
                var newItem = Object.fromEntries(new Map(this._items.map(function(item) {
                    return [
                        item.name,
                        newItemDataRow[item.name]
                    ];
                })));
                this._itemData.push((0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, newItem), {
                    __rowNumber: this._itemData.length,
                    __isDeleted: false
                }));
                return true;
            }
        },
        {
            key: "removeItemData",
            value: /**
   * Remove a single row from the data
   * @param rowNumber Row number to remove
   * @returns true is successful, false (& sets errorText) is there is an error
   */ function removeItemData(rowNumber) {
                var ix = this._itemData.findIndex(function(row) {
                    return row.__rowNumber === rowNumber;
                });
                if (ix > -1) {
                    this._itemData[ix].__isDeleted = true;
                    return true;
                } else {
                    this._errorText = "Row number not found";
                    return false;
                }
            }
        }
    ]);
    return DatasetJsonClass;
}();













function $2878136f75989e7a$export$90e11b0457a352d(action, state) {
    if (action.whereClause === undefined) throw "".concat((0, $ae1447b5ced62e91$export$4eb8423d9590796c), ": No where clause");
    else {
        var newState = (0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state);
        var _action_whereClause_WID;
        var ix = state.whereClauses.findIndex(function(w) {
            var _action_whereClause;
            return w.WID === ((_action_whereClause_WID = (_action_whereClause = action.whereClause) === null || _action_whereClause === void 0 ? void 0 : _action_whereClause.WID) !== null && _action_whereClause_WID !== void 0 ? _action_whereClause_WID : "");
        });
        if (ix === -1) newState = (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, newState), {
            whereClauses: (0, $gTuX4$swchelperscjs_to_consumable_arraycjs._)(state.whereClauses).concat([
                action.whereClause
            ])
        });
        else newState.whereClauses.splice(ix, 1, action.whereClause);
        return newState;
    }
}





var $ea913248acb2c079$export$a07c45638168b898 = function(originalArray, variable, newPosition) {
    var _ref;
    var ix = originalArray.findIndex(function(v) {
        return (_ref = v.OID === variable.OID) !== null && _ref !== void 0 ? _ref : "";
    });
    console.log("Moving variable to ".concat(newPosition, " from ").concat(ix));
    var newArray = (0, $gTuX4$swchelperscjs_to_consumable_arraycjs._)(originalArray);
    if (ix >= 0) {
        console.log("Moving");
        newArray.splice(ix, 1);
        newArray.splice(ix >= newPosition ? newPosition : newPosition - 1, 0, variable);
    } else {
        console.log("Adding ".concat(variable.name));
        newArray.splice(newPosition, 0, variable);
    }
    return newArray;
};



function $aeeae26a611471db$export$237c52930b471a42(action, state) {
    if (action.item === undefined) throw "".concat((0, $ae1447b5ced62e91$export$330817789cf72932), ": No variable specified");
    else if (action.position === undefined) throw "".concat((0, $ae1447b5ced62e91$export$330817789cf72932), ": No position defined");
    else if (action.position > state.columns.length) throw "".concat((0, $ae1447b5ced62e91$export$330817789cf72932), ": Position is too high");
    else return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state), {
        columns: (0, $ea913248acb2c079$export$a07c45638168b898)(state.columns, action.item, action.position),
        rows: state.rows.filter(function(i) {
            var _action_item;
            return i.OID !== ((_action_item = action.item) === null || _action_item === void 0 ? void 0 : _action_item.OID);
        })
    });
}






function $1d99922841608cba$export$1608945ed2884c15(action, state) {
    if (action.item === undefined) throw "".concat((0, $ae1447b5ced62e91$export$c287896b040d08eb), ": No variable specified");
    else if (action.position === undefined) throw "".concat((0, $ae1447b5ced62e91$export$c287896b040d08eb), ": No position defined");
    else if (action.position > state.rows.length) throw "".concat((0, $ae1447b5ced62e91$export$c287896b040d08eb), ": Position is too high");
    else return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state), {
        columns: state.columns.filter(function(i) {
            var _action_item;
            return i.OID !== ((_action_item = action.item) === null || _action_item === void 0 ? void 0 : _action_item.OID);
        }),
        rows: (0, $ea913248acb2c079$export$a07c45638168b898)(state.rows, action.item, action.position)
    });
}





function $7dfb5e496e3c2c3b$export$a94f51830d9bdd76(action, state) {
    if (action.item === undefined) throw "".concat((0, $ae1447b5ced62e91$export$4b9128eac4c06cf4), ": No variable specified");
    else return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state), {
        columns: state.columns.filter(function(i) {
            var _action_item;
            return i.OID !== ((_action_item = action.item) === null || _action_item === void 0 ? void 0 : _action_item.OID);
        })
    });
}





function $4f50936a25c2b480$export$3fd74043864ff5c3(action, state) {
    if (action.item === undefined) throw "".concat((0, $ae1447b5ced62e91$export$c6aa430819669f63), ": No variable specified");
    else return (0, $gTuX4$swchelperscjs_object_spread_propscjs._)((0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state), {
        rows: state.rows.filter(function(i) {
            var _action_item;
            return i.OID !== ((_action_item = action.item) === null || _action_item === void 0 ? void 0 : _action_item.OID);
        })
    });
}




function $abdcaffb5c16543b$export$3bff2824b94a5f2(action, state) {
    if (action.whereClause === undefined) throw "".concat((0, $ae1447b5ced62e91$export$d21ab455e9f38f6e), ": No where clause specified");
    else {
        var newState = (0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state);
        var _action_whereClause_WID;
        var ix = state.whereClauses.findIndex(function(w) {
            var _action_whereClause;
            return w.WID === ((_action_whereClause_WID = (_action_whereClause = action.whereClause) === null || _action_whereClause === void 0 ? void 0 : _action_whereClause.WID) !== null && _action_whereClause_WID !== void 0 ? _action_whereClause_WID : "");
        });
        if (ix > -1) newState.whereClauses.splice(ix, 1);
        return newState;
    }
}


var $ae1447b5ced62e91$export$330817789cf72932 = "MOVE_COLUMN_VARIABLE";
var $ae1447b5ced62e91$export$c287896b040d08eb = "MOVE_ROW_VARIABLE";
var $ae1447b5ced62e91$export$4b9128eac4c06cf4 = "REMOVE_COLUMN_VARIABLE";
var $ae1447b5ced62e91$export$c6aa430819669f63 = "REMOVE_ROW_VARIABLE";
var $ae1447b5ced62e91$export$d21ab455e9f38f6e = "REMOVE_WHERE_CLAUSE";
var $ae1447b5ced62e91$export$f7b453d5c91bc422 = "SET_COLUMNS";
var $ae1447b5ced62e91$export$4ccd4a26ee1aa287 = "SET_ROWS";
var $ae1447b5ced62e91$export$4eb8423d9590796c = "UPDATE_WHERE_CLAUSE";
var $ae1447b5ced62e91$export$1650419e431d3ba3 = function(state, action) {
    var newState = (0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, state);
    switch(action.type){
        case $ae1447b5ced62e91$export$330817789cf72932:
            newState = (0, $aeeae26a611471db$export$237c52930b471a42)(action, newState);
            break;
        case $ae1447b5ced62e91$export$c287896b040d08eb:
            newState = (0, $1d99922841608cba$export$1608945ed2884c15)(action, newState);
            break;
        case $ae1447b5ced62e91$export$4b9128eac4c06cf4:
            newState = (0, $7dfb5e496e3c2c3b$export$a94f51830d9bdd76)(action, newState);
            break;
        case $ae1447b5ced62e91$export$c6aa430819669f63:
            newState = (0, $4f50936a25c2b480$export$3fd74043864ff5c3)(action, newState);
            break;
        case $ae1447b5ced62e91$export$d21ab455e9f38f6e:
            newState = (0, $abdcaffb5c16543b$export$3bff2824b94a5f2)(action, newState);
            break;
        case $ae1447b5ced62e91$export$f7b453d5c91bc422:
            if (!action.columns) throw "".concat($ae1447b5ced62e91$export$f7b453d5c91bc422, ": No columns");
            else newState.columns = action.columns;
            break;
        case $ae1447b5ced62e91$export$4ccd4a26ee1aa287:
            if (!action.rows) throw "".concat($ae1447b5ced62e91$export$4ccd4a26ee1aa287, ": No rows");
            else newState.rows = action.rows;
            break;
        case $ae1447b5ced62e91$export$4eb8423d9590796c:
            newState = (0, $2878136f75989e7a$export$90e11b0457a352d)(action, newState);
            break;
    }
    console.dir(newState);
    return newState;
};


var $b469750e2535cbd1$var$initialState = {
    rows: [],
    columns: [],
    statistics: [],
    statisticPosition: "column",
    whereClauses: []
};
var $b469750e2535cbd1$export$a0a39e2218613bf9 = /*#__PURE__*/ (0, $gTuX4$react.createContext)({
    state: $b469750e2535cbd1$var$initialState,
    dispatch: function() {
        return {};
    },
    itemList: []
});
var $b469750e2535cbd1$export$ef640431176d1d1d = function(param) {
    var dataset = param.dataset, children = param.children;
    var _useReducer = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useReducer)((0, $ae1447b5ced62e91$export$1650419e431d3ba3), $b469750e2535cbd1$var$initialState), 2), state = _useReducer[0], dispatch = _useReducer[1];
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)($b469750e2535cbd1$export$a0a39e2218613bf9.Provider, {
        value: {
            state: state,
            dispatch: dispatch,
            itemList: dataset.items
        },
        children: children
    });
};


















var $733ca2d986cec59d$export$ef9b1a59e592288f = function(param) {
    var values = param.values, selected = param.selected, setSelected = param.setSelected, style = param.style, className = param.className;
    var _useState = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(selected), 2), currentValue = _useState[0], setCurrentValue = _useState[1];
    (0, $gTuX4$react.useEffect)(function() {
        return setCurrentValue(selected);
    }, [
        selected
    ]);
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        className: "selector-main ".concat(className),
        style: {
            display: "flex",
            flexDirection: "column",
            justifyContent: "center"
        },
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("select", {
            className: "selector-select",
            style: (0, $gTuX4$swchelperscjs_object_spreadcjs._)({
                borderRadius: "4px"
            }, style),
            value: currentValue,
            onChange: function(e) {
                return setCurrentValue(e.currentTarget.value);
            },
            onBlur: function(e) {
                return setSelected && setSelected(e.currentTarget.value);
            },
            children: values.map(function(k, i) {
                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("option", {
                    value: k.value,
                    children: k.label
                }, "".concat(i, "-").concat(k.value));
            })
        })
    });
};


var $f4d43cd491215d27$export$73876d288e195e34;
(function(eOperation) {
    eOperation["eq"] = "Equals";
    eOperation["lt"] = "Less than";
    eOperation["le"] = "Less than or equal to";
    eOperation["gt"] = "Greater than";
    eOperation["ge"] = "Greater than or equal to";
    eOperation["miss"] = "Missing";
    eOperation["not_miss"] = "Not missing";
    eOperation["in"] = "In";
    eOperation["not_in"] = "Not In";
})($f4d43cd491215d27$export$73876d288e195e34 || ($f4d43cd491215d27$export$73876d288e195e34 = {}));
var $f4d43cd491215d27$export$11cd368ed7b68aa7 = function(param) {
    var selected = param.selected, setSelected = param.setSelected, style = param.style, className = param.className;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $733ca2d986cec59d$export$ef9b1a59e592288f), {
        className: "eoperation-selector ".concat(className),
        style: (0, $gTuX4$swchelperscjs_object_spreadcjs._)({
            width: "170px"
        }, style),
        values: Object.keys($f4d43cd491215d27$export$73876d288e195e34).map(function(k, i) {
            return {
                value: k,
                label: Object.values($f4d43cd491215d27$export$73876d288e195e34)[i]
            };
        }),
        selected: selected,
        setSelected: setSelected ? function(ret) {
            return setSelected(ret);
        } : undefined
    });
};



var $518851206338b7e8$export$5471ddcbd29402fc = /*#__PURE__*/ function() {
    "use strict";
    function WhereClauseClass(newWhereClause) {
        (0, $gTuX4$swchelperscjs_class_call_checkcjs._)(this, WhereClauseClass);
        this._WID = "";
        this._previousVersions = [];
        this._item = null;
        this._whereOperation = null;
        this._filteredItemValues = [];
        var _newWhereClause_WID;
        this._WID = (_newWhereClause_WID = newWhereClause === null || newWhereClause === void 0 ? void 0 : newWhereClause.WID) !== null && _newWhereClause_WID !== void 0 ? _newWhereClause_WID : crypto.randomUUID();
        var _newWhereClause_item;
        this._item = (_newWhereClause_item = newWhereClause === null || newWhereClause === void 0 ? void 0 : newWhereClause.item) !== null && _newWhereClause_item !== void 0 ? _newWhereClause_item : null;
        var _newWhereClause_whereOperation;
        this._whereOperation = (_newWhereClause_whereOperation = newWhereClause === null || newWhereClause === void 0 ? void 0 : newWhereClause.whereOperation) !== null && _newWhereClause_whereOperation !== void 0 ? _newWhereClause_whereOperation : null;
        var _newWhereClause_filteredItemValues;
        this._filteredItemValues = (_newWhereClause_filteredItemValues = newWhereClause === null || newWhereClause === void 0 ? void 0 : newWhereClause.filteredItemValues) !== null && _newWhereClause_filteredItemValues !== void 0 ? _newWhereClause_filteredItemValues : [];
    }
    (0, $gTuX4$swchelperscjs_create_classcjs._)(WhereClauseClass, [
        {
            key: "WID",
            get: /**
   * Unique Id attribute
   */ function get() {
                return this._WID;
            }
        },
        {
            key: "previousVersions",
            get: function get() {
                return this._previousVersions;
            }
        },
        {
            key: "item",
            get: /**
   * Item to check
   */ function get() {
                return this._item;
            },
            set: /**
   * Item to check
   */ function set(newItem) {
                this._item = newItem;
            }
        },
        {
            key: "whereOperation",
            get: /**
   *  Operation
   */ function get() {
                return this._whereOperation;
            },
            set: /**
   * Operation
   */ function set(newOperation) {
                this._whereOperation = newOperation;
            }
        },
        {
            key: "filteredItemValues",
            get: /**
   * Values for condition
   */ function get() {
                return this._filteredItemValues;
            },
            set: /**
   * Values for condition
   */ function set(newValues) {
                if (newValues === undefined) this._filteredItemValues;
                else if (!this._item) throw new Error("WhereClause: Can not set values where there is no item");
                else if (this._item.type === (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).string && newValues.some(function(v) {
                    return typeof v !== "string";
                })) throw new Error("WhereClause: Can only set string values for a string item");
                else if ([
                    (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).integer,
                    (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).float
                ].includes(this._item.type) && newValues.some(function(v) {
                    return typeof v !== "number";
                })) throw new Error("WhereClause: Can only set number values for a integer or float items");
                else if ([
                    (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).date,
                    (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).datetime,
                    (0, $db8b278ed6b17d1f$export$a3d0be471ff2ca15).time
                ].includes(this._item.type) && newValues.some(function(v) {
                    return !(v instanceof Date);
                })) throw new Error("WhereClause: Can only set date values for a date, datetime or time items");
                else this._filteredItemValues = newValues;
            }
        },
        {
            key: "isValid",
            get: /**
   * Check if current where clause is valid
   */ function get() {
                var _this_filteredItemValues, _this__filteredItemValues, _this__filteredItemValues1;
                var _this__filteredItemValues_length;
                return this._WID && this._item && this._whereOperation && ([
                    (0, $f4d43cd491215d27$export$73876d288e195e34).miss,
                    (0, $f4d43cd491215d27$export$73876d288e195e34).not_miss
                ].includes(this._whereOperation) && ((_this_filteredItemValues = this.filteredItemValues) === null || _this_filteredItemValues === void 0 ? void 0 : _this_filteredItemValues.length) === 0 || [
                    (0, $f4d43cd491215d27$export$73876d288e195e34).eq,
                    (0, $f4d43cd491215d27$export$73876d288e195e34).ge,
                    (0, $f4d43cd491215d27$export$73876d288e195e34).gt,
                    (0, $f4d43cd491215d27$export$73876d288e195e34).le,
                    (0, $f4d43cd491215d27$export$73876d288e195e34).lt
                ].includes(this._whereOperation) && ((_this__filteredItemValues = this._filteredItemValues) === null || _this__filteredItemValues === void 0 ? void 0 : _this__filteredItemValues.length) === 1 || ((0, $f4d43cd491215d27$export$73876d288e195e34).in, (0, $f4d43cd491215d27$export$73876d288e195e34).not_in, ((_this__filteredItemValues_length = (_this__filteredItemValues1 = this._filteredItemValues) === null || _this__filteredItemValues1 === void 0 ? void 0 : _this__filteredItemValues1.length) !== null && _this__filteredItemValues_length !== void 0 ? _this__filteredItemValues_length : -1) > 0));
            }
        },
        {
            key: "update",
            value: /**
   * Update existing where clause, and save previous version if valid
   * @param itemName new name
   * @param whereOperation: new operation
   * @param filteredItemValues: new item values
   */ function update(itemName, whereOperation, filteredItemValues) {
                if (this._item && this._whereOperation && this.isValid) {
                    var currentVersion = {
                        timestamp: new Date(),
                        _itemName: this._item,
                        _whereOperation: this._whereOperation,
                        _filteredItemValues: this._filteredItemValues
                    };
                    this._previousVersions.push(currentVersion);
                }
                this._item = itemName;
                this._whereOperation = whereOperation;
                this._filteredItemValues = filteredItemValues;
            }
        }
    ]);
    return WhereClauseClass;
}();

















var $d6e0fe0183f427b7$export$79660a248b11010 = function(param) {
    var id = param.id, dropAction = param.dropAction, children = param.children, style = param.style, type = param.type;
    var _useState = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(false), 2), isOver = _useState[0], setIsOver = _useState[1];
    var summaryTableContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9));
    var handleDrop = function(e) {
        console.log("Dropped: " + e.dataTransfer);
        setIsOver(false);
        e.stopPropagation();
        e.preventDefault();
        if (e.dataTransfer.types[0] === "application/datasetjsonitem") try {
            var data = JSON.parse(e.dataTransfer.getData("application/datasetjsonitem"));
            console.log("Data dropped");
            console.log(data);
            var ix = summaryTableContext.itemList.findIndex(function(v) {
                return v.OID === data.OID;
            });
            if (ix > -1) {
                var item = summaryTableContext.itemList[ix];
                dropAction && dropAction({
                    type: "variable",
                    data: item
                });
            }
        } catch (error) {
            console.warn("Something has gone wrong :( dropping on ".concat(id));
            console.warn(error);
        }
    };
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        id: id,
        className: "drop-target ".concat(isOver ? "can-drop" : "", " ").concat(type),
        onDragOver: function(e) {
            if (e.dataTransfer.types[0] === "application/datasetjsonitem") {
                setIsOver(true);
                e.preventDefault();
                e.stopPropagation();
            }
        },
        onDrop: handleDrop,
        onDragLeave: function() {
            return setIsOver(false);
        },
        style: (0, $gTuX4$swchelperscjs_object_spreadcjs._)({}, style),
        children: children !== null && children !== void 0 ? children : /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$reactjsxruntime.Fragment), {
            children: "​"
        })
    });
};








var $98aa2becec68190a$export$b62643f540e1ded8 = function(param) {
    var item = param.item, setItem = param.setItem;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
        children: [
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                children: item.OID
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                children: item.name
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                children: item.label
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                children: item.type
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                children: item.length
            })
        ]
    });
};


var $9365d980205143a7$export$de69795869716f53 = function(param) {
    var id = param.id, item = param.item;
    var _useState = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(false), 2), isBeingDragged = _useState[0], setIsBeingDragged = _useState[1];
    var _useState1 = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(false), 2), showProperties = _useState1[0], setShowProperties = _useState1[1];
    var handleDragStart = function(e) {
        if (item) {
            console.log("Drag start for " + item.name);
            setIsBeingDragged(true);
            e.dataTransfer.setData("application/datasetjsonitem", item.toString);
        }
    };
    var handleDragEnd = function(e) {
        if (item) {
            console.log(e);
            console.log("Drag end for " + item.name);
            setIsBeingDragged(false);
        }
    };
    var _item_name;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)((0, $gTuX4$reactjsxruntime.Fragment), {
        children: [
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextMenuHandler), {
                menuItems: item ? [
                    {
                        label: "Properties",
                        action: function() {
                            return setShowProperties(true);
                        }
                    }
                ] : [],
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                    id: id,
                    className: "item-holder ".concat(isBeingDragged ? "being-dragged" : ""),
                    draggable: true,
                    onDragStart: handleDragStart,
                    onDragEnd: handleDragEnd,
                    children: (_item_name = item === null || item === void 0 ? void 0 : item.name) !== null && _item_name !== void 0 ? _item_name : /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("em", {
                        children: "Drop item here"
                    })
                })
            }),
            item && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextWindow), {
                id: "item-properties-window",
                visible: showProperties,
                title: "".concat(item === null || item === void 0 ? void 0 : item.label, " properties"),
                onClose: function() {
                    return setShowProperties(false);
                },
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $98aa2becec68190a$export$b62643f540e1ded8), {
                    item: item
                })
            })
        ]
    });
};


var $dcfdf7b4117922a7$export$a957d45f359dcc = function(param) {
    var index = param.index;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, dispatch = _useContext.dispatch;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        className: "itemholder-main",
        style: {
            position: "relative",
            width: "166px",
            height: "40px"
        },
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d6e0fe0183f427b7$export$79660a248b11010), {
            id: "whereclauseitem-".concat(index, "-droptarget"),
            type: "center",
            dropAction: function(ret) {
                var _state_whereClauses_index, _state_whereClauses_index1, _state_whereClauses_index2;
                var _state_whereClauses_index_whereOperation;
                if (ret.data instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)) dispatch({
                    type: (0, $ae1447b5ced62e91$export$4eb8423d9590796c),
                    whereClause: new (0, $518851206338b7e8$export$5471ddcbd29402fc)({
                        WID: (_state_whereClauses_index = state.whereClauses[index]) === null || _state_whereClauses_index === void 0 ? void 0 : _state_whereClauses_index.WID,
                        item: ret.data,
                        whereOperation: (_state_whereClauses_index_whereOperation = (_state_whereClauses_index1 = state.whereClauses[index]) === null || _state_whereClauses_index1 === void 0 ? void 0 : _state_whereClauses_index1.whereOperation) !== null && _state_whereClauses_index_whereOperation !== void 0 ? _state_whereClauses_index_whereOperation : null,
                        filteredItemValues: (_state_whereClauses_index2 = state.whereClauses[index]) === null || _state_whereClauses_index2 === void 0 ? void 0 : _state_whereClauses_index2.filteredItemValues
                    })
                });
            },
            children: state.whereClauses[index] ? /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $9365d980205143a7$export$de69795869716f53), {
                id: "whereclauseitem-".concat(index),
                item: state.whereClauses[index].item
            }) : /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                id: "whereclauseitem-".concat(index),
                className: "item-holder"
            })
        })
    });
};


var $370e260080611c42$export$45934bc448f597d1 = function(param) {
    var index = param.index, canEdit = param.canEdit;
    var _state_whereClauses_index, _state_whereClauses_index1, _state_whereClauses_index_filteredItemValues;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, dispatch = _useContext.dispatch;
    if (!state.whereClauses[index]) return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$reactjsxruntime.Fragment), {});
    var _state_whereClauses_index_whereOperation, _state_whereClauses_index_filteredItemValues_map;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
        className: "whereclause-main",
        style: {
            display: "flex",
            flexDirection: "row"
        },
        children: [
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                className: "whereclause-remove-holder",
                style: {
                    display: "flex",
                    flexDirection: "column",
                    justifyContent: "center"
                },
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("svg", {
                    xmlns: "http://www.w3.org/2000/svg",
                    width: "16",
                    height: "16",
                    fill: "currentColor",
                    className: "bi bi-dash-circle",
                    viewBox: "0 0 16 16",
                    color: "red",
                    onClick: canEdit ? function() {
                        return dispatch({
                            type: (0, $ae1447b5ced62e91$export$d21ab455e9f38f6e),
                            whereClause: state.whereClauses[index]
                        });
                    } : undefined,
                    children: [
                        /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("path", {
                            d: "M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"
                        }),
                        /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("path", {
                            d: "M4 8a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7A.5.5 0 0 1 4 8z"
                        })
                    ]
                })
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $dcfdf7b4117922a7$export$a957d45f359dcc), {
                index: index
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $f4d43cd491215d27$export$11cd368ed7b68aa7), {
                selected: (_state_whereClauses_index_whereOperation = (_state_whereClauses_index = state.whereClauses[index]) === null || _state_whereClauses_index === void 0 ? void 0 : _state_whereClauses_index.whereOperation) !== null && _state_whereClauses_index_whereOperation !== void 0 ? _state_whereClauses_index_whereOperation : "",
                setSelected: canEdit ? function(ret) {
                    var _state_whereClauses_index, _state_whereClauses_index1, _state_whereClauses_index2;
                    dispatch({
                        type: (0, $ae1447b5ced62e91$export$4eb8423d9590796c),
                        whereClause: new (0, $518851206338b7e8$export$5471ddcbd29402fc)({
                            WID: (_state_whereClauses_index = state.whereClauses[index]) === null || _state_whereClauses_index === void 0 ? void 0 : _state_whereClauses_index.WID,
                            item: (_state_whereClauses_index1 = state.whereClauses[index]) === null || _state_whereClauses_index1 === void 0 ? void 0 : _state_whereClauses_index1.item,
                            whereOperation: ret !== null && ret !== void 0 ? ret : null,
                            filteredItemValues: (_state_whereClauses_index2 = state.whereClauses[index]) === null || _state_whereClauses_index2 === void 0 ? void 0 : _state_whereClauses_index2.filteredItemValues
                        })
                    });
                } : undefined
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                className: "whereclause-values",
                children: (_state_whereClauses_index_filteredItemValues_map = (_state_whereClauses_index1 = state.whereClauses[index]) === null || _state_whereClauses_index1 === void 0 ? void 0 : (_state_whereClauses_index_filteredItemValues = _state_whereClauses_index1.filteredItemValues) === null || _state_whereClauses_index_filteredItemValues === void 0 ? void 0 : _state_whereClauses_index_filteredItemValues.map(function(v, i) {
                    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                        children: v instanceof Date ? new Date(v.getTime() - v.getTimezoneOffset() * 60000).toISOString().replace(/T/, " ").slice(0, 16) : v
                    }, i);
                })) !== null && _state_whereClauses_index_filteredItemValues_map !== void 0 ? _state_whereClauses_index_filteredItemValues_map : "No values set"
            })
        ]
    });
};



var $59b33d2c124d6e0f$export$ff96b50e24156646 = function(param) {
    var _param_editable = param.editable, editable = _param_editable === void 0 ? true : _param_editable;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, dispatch = _useContext.dispatch;
    var _useState = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(false), 2), showWindow = _useState[0], setShowWindow = _useState[1];
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        className: "stwhere-main",
        style: {
            height: "24px"
        },
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
            className: "",
            children: [
                state.whereClauses.length,
                " filter",
                state.whereClauses.length === 1 ? "" : "s",
                " applied",
                /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("span", {
                    className: "stwhere-edit-button",
                    title: "Edit filters",
                    style: {
                        cursor: "pointer"
                    },
                    onClick: function() {
                        return setShowWindow(true);
                    },
                    children: "…"
                }),
                /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextWindow), {
                    visible: showWindow,
                    id: "stwhere-window",
                    title: "Where clauses",
                    onClose: function() {
                        return setShowWindow(false);
                    },
                    style: {
                        width: "500px"
                    },
                    children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                        className: "stwhere-main",
                        children: [
                            state.whereClauses.map(function(_, i) {
                                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $370e260080611c42$export$45934bc448f597d1), {
                                    index: i,
                                    canEdit: true
                                }, i);
                            }),
                            editable && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                                className: "stwhere-add-where-clause",
                                onClick: function() {
                                    if (!state.whereClauses.some(function(w) {
                                        return !w.isValid;
                                    })) dispatch({
                                        type: (0, $ae1447b5ced62e91$export$4eb8423d9590796c),
                                        whereClause: new (0, $518851206338b7e8$export$5471ddcbd29402fc)()
                                    });
                                },
                                children: [
                                    /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("svg", {
                                        xmlns: "http://www.w3.org/2000/svg",
                                        width: "16",
                                        height: "16",
                                        fill: "currentColor",
                                        className: "bi bi-plus-circle",
                                        viewBox: "0 0 16 16",
                                        children: [
                                            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("path", {
                                                d: "M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"
                                            }),
                                            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("path", {
                                                d: "M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"
                                            })
                                        ]
                                    }),
                                    " ",
                                    "Add where clause"
                                ]
                            })
                        ]
                    })
                })
            ]
        })
    });
};















var $14db52552fa11f60$export$8223a8de810b6079 = function(param) {
    var id = param.id, onDropTop = param.onDropTop, onDropLeft = param.onDropLeft, onDropBottom = param.onDropBottom, onDropRight = param.onDropRight, children = param.children;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)((0, $gTuX4$reactjsxruntime.Fragment), {
        children: [
            onDropTop && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d6e0fe0183f427b7$export$79660a248b11010), {
                id: "".concat(id, "-drop-top"),
                type: "top",
                dropAction: onDropTop
            }),
            onDropLeft && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d6e0fe0183f427b7$export$79660a248b11010), {
                id: "".concat(id, "-drop-left"),
                type: "left",
                dropAction: onDropLeft
            }),
            " ",
            onDropBottom && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d6e0fe0183f427b7$export$79660a248b11010), {
                id: "".concat(id, "-drop-bottom"),
                type: "bottom",
                dropAction: onDropBottom
            }),
            onDropRight && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d6e0fe0183f427b7$export$79660a248b11010), {
                id: "".concat(id, "-drop-right"),
                type: "right",
                dropAction: onDropRight
            }),
            children
        ]
    });
};







var $648efe0835e1ea0f$export$69d1b0f1fb6d6c3c = function(param) {
    var id = param.id, statistic = param.statistic;
    var _useState = (0, $gTuX4$swchelperscjs_sliced_to_arraycjs._)((0, $gTuX4$react.useState)(false), 2), isBeingDragged = _useState[0], setIsBeingDragged = _useState[1];
    var handleDragStart = function(e) {
        console.log("Drag start for " + statistic);
        setIsBeingDragged(true);
        e.dataTransfer.setData("application/json", JSON.stringify({
            type: "statistic",
            data: statistic
        }));
    };
    var handleDragEnd = function(e) {
        console.log(e);
        console.log("Drag end for " + statistic);
        setIsBeingDragged(false);
    };
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        id: id,
        className: "statistic-holder ".concat(isBeingDragged ? "being-dragged" : ""),
        draggable: true,
        onDragStart: handleDragStart,
        onDragEnd: handleDragEnd,
        children: statistic
    });
};



var $d5755bb7af27d6cd$export$85f64913aa0376d6 = function(param) {
    var id = param.id, index = param.index;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, dispatch = _useContext.dispatch;
    var item = (0, $gTuX4$react.useMemo)(function() {
        return state.columns[index];
    }, [
        index,
        state.columns
    ]);
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("th", {
        style: {
            position: "relative"
        },
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextMenuHandler), {
            menuItems: [
                {
                    label: "Remove",
                    action: function() {
                        return dispatch({
                            type: (0, $ae1447b5ced62e91$export$4b9128eac4c06cf4),
                            item: item
                        });
                    }
                }
            ],
            style: {
                width: "100%",
                height: "100%"
            },
            children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $14db52552fa11f60$export$8223a8de810b6079), {
                id: id,
                onDropRight: function(ret) {
                    if (ret.data instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)) dispatch({
                        type: (0, $ae1447b5ced62e91$export$330817789cf72932),
                        position: index + 1,
                        item: ret.data
                    });
                },
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)((0, $gTuX4$reactjsxruntime.Fragment), {
                    children: [
                        /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $9365d980205143a7$export$de69795869716f53), {
                            id: "".concat(id, "-column-header-").concat(index),
                            item: item
                        }),
                        state.statisticPosition === "column" && /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                            style: {
                                display: "flex",
                                flexDirection: "row"
                            },
                            children: state.statistics.map(function(s, i) {
                                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $648efe0835e1ea0f$export$69d1b0f1fb6d6c3c), {
                                    id: "".concat(id, "-statistic-").concat(i),
                                    statistic: s
                                }, i);
                            })
                        })
                    ]
                })
            })
        })
    }, item.name);
};














var $abebae0b586944b4$export$d89398cb9fcd80d3 = function(param) {
    var index = param.rowIndex;
    var state = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)).state;
    var _item_OID;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$reactjsxruntime.Fragment), {
        children: state.columns.map(function(item, ci) {
            return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("td", {
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                    className: "data-cell",
                    style: {
                        textAlign: "center"
                    },
                    children: [
                        state.rows[index].label,
                        /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("br", {}),
                        "x",
                        /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("br", {}),
                        item.label
                    ]
                })
            }, (_item_OID = item.OID) !== null && _item_OID !== void 0 ? _item_OID : ci);
        })
    });
};



var $982c6f1219bd2f12$export$970f9fff6f256d9c = function(param) {
    var id = param.id, index = param.index;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, dispatch = _useContext.dispatch;
    var item = (0, $gTuX4$react.useMemo)(function() {
        return state.rows[index];
    }, [
        state.rows,
        index
    ]);
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("tr", {
        children: [
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("td", {
                style: {
                    position: "relative"
                },
                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextMenuHandler), {
                    menuItems: [
                        {
                            label: "Remove",
                            action: function() {
                                return dispatch({
                                    type: (0, $ae1447b5ced62e91$export$c6aa430819669f63),
                                    item: item
                                });
                            }
                        }
                    ],
                    children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $14db52552fa11f60$export$8223a8de810b6079), {
                        id: "".concat(id),
                        onDropBottom: function(ret) {
                            if (ret.data instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)) dispatch({
                                type: (0, $ae1447b5ced62e91$export$c287896b040d08eb),
                                position: index + 1,
                                item: ret.data
                            });
                        },
                        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $9365d980205143a7$export$de69795869716f53), {
                            id: "".concat(id, "-column-header-").concat(index),
                            item: item
                        })
                    })
                })
            }),
            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $abebae0b586944b4$export$d89398cb9fcd80d3), {
                rowIndex: index
            })
        ]
    }, item.name);
};









var $a2ee8cb2d260154f$export$8b93e255184bda71 = function(param) {
    var id = param.id;
    var dispatch = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)).dispatch;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("th", {
        style: {
            position: "relative"
        },
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $14db52552fa11f60$export$8223a8de810b6079), {
            id: "".concat(id, "-drop-edges"),
            onDropBottom: function(ret) {
                if (ret.data instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)) dispatch({
                    type: (0, $ae1447b5ced62e91$export$c287896b040d08eb),
                    position: 0,
                    item: ret.data
                });
            },
            onDropRight: function(ret) {
                if (ret.data instanceof (0, $db8b278ed6b17d1f$export$626c488e6c24a1e8)) dispatch({
                    type: (0, $ae1447b5ced62e91$export$330817789cf72932),
                    position: 0,
                    item: ret.data
                });
            },
            children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                className: "tl-cell-holder"
            })
        })
    });
};


var $9d6796c58ac2c54d$export$4f0abbd4b5b22d8a = function(param) {
    var id = param.id;
    var state = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)).state;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        className: "drop-table-holder",
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("table", {
            id: id,
            className: "drop-table",
            children: [
                /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("thead", {
                    children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("tr", {
                        children: [
                            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $a2ee8cb2d260154f$export$8b93e255184bda71), {
                                id: "".concat(id, "-tl-cell")
                            }),
                            state.columns.map(function(v, i) {
                                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $d5755bb7af27d6cd$export$85f64913aa0376d6), {
                                    id: "".concat(id, "-header-variable-").concat(i),
                                    index: i
                                }, "".concat(i, ":").concat(v.OID));
                            })
                        ]
                    })
                }),
                /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("tbody", {
                    children: state.rows.map(function(v, i) {
                        return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $982c6f1219bd2f12$export$970f9fff6f256d9c), {
                            id: "".concat(id, "-row-variable-").concat(i),
                            index: i
                        }, "".concat(i, ":").concat(v.OID));
                    })
                })
            ]
        })
    });
};







var $01d1464f157a052f$export$168eb813a5fc3f58 = function(param) {
    var id = param.id;
    var _useContext = (0, $gTuX4$react.useContext)((0, $b469750e2535cbd1$export$a0a39e2218613bf9)), state = _useContext.state, itemList = _useContext.itemList;
    var _variable_OID;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
        className: "item-list simpletable-main small-scrollbar",
        id: id,
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
            className: "simpletable-holder",
            children: itemList.filter(function(v) {
                var _state_target;
                return !state.columns.map(function(c) {
                    return c.name;
                }).includes(v.name) && !state.rows.map(function(r) {
                    return r.name;
                }).includes(v.name) && ((_state_target = state.target) === null || _state_target === void 0 ? void 0 : _state_target.name) !== v.name;
            }).map(function(variable, index) {
                return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $9365d980205143a7$export$de69795869716f53), {
                    id: "".concat(id, "-").concat(variable.name),
                    item: variable
                }, (_variable_OID = variable.OID) !== null && _variable_OID !== void 0 ? _variable_OID : index);
            })
        })
    });
};


var $1c005ff3adb0923f$export$8bd6da0e23c354ec = function(param) {
    var dataset = param.dataset;
    return /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $gTuX4$asupcontextmenu.ContextWindowStack), {
        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $b469750e2535cbd1$export$ef640431176d1d1d), {
            dataset: dataset,
            children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                className: "summarytablegenerator",
                children: [
                    /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                        className: "simpletable-title-holder",
                        children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("h5", {
                            className: "simpletable-title",
                            children: [
                                "Summary table for: ",
                                dataset.name
                            ]
                        })
                    }),
                    /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                        className: "summarytable-main-holder",
                        style: {
                            display: "flex",
                            flexDirection: "row",
                            height: "calc(100% - 46px)"
                        },
                        children: [
                            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)("div", {
                                className: "summarytable-lhs",
                                style: {
                                    width: "190px",
                                    height: "100%"
                                },
                                children: /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $01d1464f157a052f$export$168eb813a5fc3f58), {
                                    id: "summarytable-items"
                                })
                            }),
                            /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsxs)("div", {
                                className: "summarytable-rhs",
                                style: {
                                    width: "calc(100% - 190px)",
                                    height: "100%",
                                    display: "flex",
                                    flexDirection: "column"
                                },
                                children: [
                                    /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $59b33d2c124d6e0f$export$ff96b50e24156646), {}),
                                    /*#__PURE__*/ (0, $gTuX4$reactjsxruntime.jsx)((0, $9d6796c58ac2c54d$export$4f0abbd4b5b22d8a), {
                                        id: "summarytable"
                                    })
                                ]
                            })
                        ]
                    })
                ]
            })
        })
    });
};




//# sourceMappingURL=main.js.map
